#!/bin/bash

# VARIABLES
APT_OPTIONS="-o Dir::State=tmp/downloader/var/lib/apt/ -o Dir::State::status=/tmp/downloader/var/lib/dpkg/status -o Dir::Etc=tmp/downloader/etc/apt/ -o Dir::Cache=/var/cache/apt/archives.download"
TMPDIR=/tmp/downloader

mkdir -p /var/cache/apt/archives.download/archives/partial 

for pkg in $(ls /var/cache/apt/archives | grep deb)
do
  mv /var/cache/apt/archives/$pkg /var/cache/apt/archives.download/archives/$pkg
done

for pkg in $(ls /var/cache/apt/archives.download | grep deb)
do
  mv /var/cache/apt/archives.download/$pkg /var/cache/apt/archives.download/archives/$pkg
done



mkdir -p $TMPDIR
mkdir -p $TMPDIR/var/lib/apt/lists/partial
mkdir -p $TMPDIR/var/lib/dpkg
mkdir -p $TMPDIR/var/cache/apt/archives/partial
mkdir -p $TMPDIR/etc/apt

cat > $TMPDIR/etc/apt/sources.list <<EOF
deb http://arwen.emergya.info/~ggv4/pool/ ./
deb http://archive.ubuntu.com/ubuntu edgy main restricted universe multiverse
deb http://v4.guadalinex.org/ubuntu edgy main restricted universe multiverse
deb http://v4.guadalinex.org/guadalinex-toro toro main restricted universe multiverse
deb http://v4.guadalinex.org/guadalinex-toro toro-updates main restricted universe multiverse
deb http://v4.guadalinex.org/guadalinex-toro toro-security main restricted universe multiverse
deb http://v4.guadalinex.org/guadalinex-toro toro-backports main restricted universe multiverse
deb http://archive.canonical.com/ edgy-commercial main
EOF

MAX_TRIES=3
TRY_NUM=0

while [ $TRY_NUM -le $MAX_TRIES ]; do

  let TRY_NUM=$TRY_NUM+1

  rm -f $TMPDIR/var/lib/dpkg/status
  touch $TMPDIR/var/lib/dpkg/status

  apt-get $APT_OPTIONS update

  apt-get $APT_OPTIONS --yes --force-yes -d install guadalinfo-v4-server-system guadalinfo-v4-common guadalinfo-v4-server guadalinfo-v4-client meta-guadalinex-v4 realplay
  MISC_PKGS="$?"
  
  rm $TMPDIR/var/lib/dpkg/status
  ln /var/lib/dpkg/status $TMPDIR/var/lib/dpkg/status
  
  apt-get $APT_OPTIONS --yes --force-yes -d dist-upgrade
  UP_PKGS="$?"
  
  cd /var/cache/apt/archives.download/archives/
  if [ -f skype_debian-1.3.0.53-1_i386.deb ]; then
  	MD5=$(md5sum skype_debian-1.3.0.53-1_i386.deb  | awk '{print $1}')
  	if [ "$MD5" != "a81244827d18502d7f597ae491b0e3fd" ]; then
  		wget http://skype.com/go/getskype-linux-deb
  		SKYPE="$?"
  	else
  		SKYPE="0"
  	fi
  else
  	wget http://skype.com/go/getskype-linux-deb
  	SKYPE="$?"
  fi
  cd -

# Comprobamos si quedan paquetes "a medias" 
  PENDING_NUM=$( ls -1 /var/cache/apt/archives/partial | wc -l )
  if [ $PENDING_NUM = "0" ]; then
    break
  else
    if [ $TRY_NUM -le $MAX_TRIES ]; then
      echo "Pendientes $PENDING_NUM paquetes por descargar... Reintentamos descarga ($TRY_NUM)"
    fi
  fi

done

if [[ "$MISC_PKGS" == "0" && "$UP_PKGS" == "0"  && "$SKYPE" == "0" ]]; then
  touch /var/local/ggv4-downloaded
  for pkg in $(ls /var/cache/apt/archives.download/archives | grep deb)
  do
     ln /var/cache/apt/archives.download/archives/$pkg /var/cache/apt/archives/$pkg
  done
fi
exit 0
